=== awisetoolbox/qt/utilities/CMakeLists.txt ===
#
# CMakeLists.txt
# CMake makefile for the A.Wise Toolbox Qt Utilities library.
#

#
# This file is part of awisetoolbox.
# Copyright (C) 2008-2017 by Alan Wise (awisesoftware@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


#
# Configuration
#

# Display name.
SET(DISPLAYNAME "Qt Utilities Library")

# Build information.
SET(LIBRARYNAME "${AWISETOOLBOX_BASENAME}qtutilities")
SET(MAJORVERSION ${AWISETOOLBOX_MAJORVERSION})
SET(MINORVERSION ${AWISETOOLBOX_MINORVERSION})
SET(PATCHVERSION ${AWISETOOLBOX_PATCHVERSION})
SET(DESCRIPTION
    "A Qt specific collection of code and data which can be used on"
    " multiple projects.")
STRING(REPLACE ";" "" DESCRIPTION "${DESCRIPTION}")

# Directories.
SET(CMAKE_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/cmake/")
SET(FORMS_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/forms/")
SET(RESOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/resources/")
SET(SOURCES_DIR "${PROJECT_SOURCE_DIR}/qt/utilities/sources/")


#
# Include paths
#

SET(INCLUDE_DIRECTORIES
    "${PROJECT_SOURCE_DIR}/generic/sources/")
STRING(REPLACE ";" "\" \\\n\""
    TEMP_DOXYGEN_INCLUDE_PATHS "\"${INCLUDE_DIRECTORIES}\"")
STRING(CONCAT DOXYGEN_INCLUDE_PATHS
    "${DOXYGEN_INCLUDE_PATHS} \\\n${TEMP_DOXYGEN_INCLUDE_PATHS}")
INCLUDE_DIRECTORIES(
    "${INCLUDE_DIRECTORIES}")


#
# Sources
#

INCLUDE("cmake/documentation.cmake")
INCLUDE("cmake/library.cmake")
INCLUDE("cmake/test.cmake")


#
# Binaries
#


#
# Subdirectories
#


#
# Installation
#


#
# CMakeLists.txt
#
