=== debian/changelog ===
moonphase (0.5.0-1mx19+1) mx; urgency=medium

  * Rebuild for MX 19.
  * Bump debhelper compat to 9.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Oct 2019 16:44:21 -0700

moonphase (0.5.0-1mx17+1) mx; urgency=medium

  * New release repackaged for MX 17.

 -- Mike Purtell <mmikeinsantarosa@mxlinux.org>  Sun, 06 May 2018 07:04:20 -0700
