=== debian/control ===
Source: moonphase
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Mike Purtell (mmikeinsantarosa) <maintainer@mepiscommunity.org>
Build-Depends: debhelper (>= 9),
 cmake (>= 2.8),
 libqt4-dev
Standards-Version: 3.9.4
Homepage: http://moonphase.sourceforge.net/
Vcs-Git: https://gitlab.com/moonphase/moonphase
#Vcs-Browser: http://sourceforge.net/p/moonphase/code/ci/master/tree/

Package: moonphase-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Displays the phase of the moon in the system tray.
 Displays the phase of the moon in the system tray. Additionally, a window
 can be displayed that shows user selectable data about the moon
 (rise/set times, percent illumination, etc).
